package gov.anl.aps.dm.common.constants;

/**
 * DM service protocol enum.
 */
public enum DmServiceProtocol {

    HTTP("http"),
    HTTPS("https");

    private final String type;

    private DmServiceProtocol(String type) {
        this.type = type;
    }

    @Override
    public String toString() {
        return type;
    }

    public static DmServiceProtocol fromString(String type) {
        DmServiceProtocol protocol = null;
        switch (type) {
            case "http":
                protocol = HTTP;
                break;
            case "https":
                protocol = HTTPS;
                break;
        }
        return protocol;
    }
}
