package gov.anl.aps.dm.common.exceptions;

import gov.anl.aps.dm.common.constants.DmStatus;

/**
 * Configuration error exception.
 */
public class ConfigurationError extends DmException {

    /**
     * Default constructor.
     */
    public ConfigurationError() {
        super();
    }

    /**
     * Constructor using error message.
     *
     * @param message error message
     */
    public ConfigurationError(String message) {
        super(message);
    }

    /**
     * Constructor sing throwable object.
     *
     * @param throwable throwable object
     */
    public ConfigurationError(Throwable throwable) {
        super(throwable);
    }

    /**
     * Constructor using error message and throwable object.
     *
     * @param message error message
     * @param throwable throwable object
     */
    public ConfigurationError(String message, Throwable throwable) {
        super(message, throwable);
    }

    @Override
    public int getErrorCode() {
        return DmStatus.DM_CONFIGURATION_ERROR;
    }    
}
