package gov.anl.aps.dm.common.exceptions;

import gov.anl.aps.dm.common.constants.DmStatus;

/**
 * Invalid request exception.
 */
public class InvalidRequest extends DmException {

    /**
     * Default constructor.
     */
    public InvalidRequest() {
        super();
    }

    /**
     * Constructor using error message.
     *
     * @param message error message
     */
    public InvalidRequest(String message) {
        super(message);
    }

    /**
     * Constructor using throwable object.
     *
     * @param throwable throwable object
     */
    public InvalidRequest(Throwable throwable) {
        super(throwable);
    }

    /**
     * Constructor using error message and throwable object.
     *
     * @param message error message
     * @param throwable throwable object
     */
    public InvalidRequest(String message, Throwable throwable) {
        super(message, throwable);
    }

    @Override
    public int getErrorCode() {
        return DmStatus.DM_INVALID_REQUEST;
    }    
}
