package gov.anl.aps.dm.portal.controllers;

import gov.anl.aps.dm.portal.model.beans.SystemRoleTypeDbFacade;
import gov.anl.aps.dm.portal.model.entities.SystemRoleType;
import javax.ejb.EJB;
import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;
import org.apache.log4j.Logger;

@Named("systemRoleTypeController")
@SessionScoped
public class SystemRoleTypeController extends DmEntityController<SystemRoleType, SystemRoleTypeDbFacade> {

    private static final Logger logger = Logger.getLogger(SystemRoleTypeController.class.getName());

    @EJB
    private SystemRoleTypeDbFacade systemRoleTypeDbFacade;

    public SystemRoleTypeController() {
    }

    @Override
    protected SystemRoleTypeDbFacade getFacade() {
        return systemRoleTypeDbFacade;
    }

    @Override
    protected SystemRoleType createEntityInstance() {
        return new SystemRoleType();
    }

    @Override
    public String getEntityTypeName() {
        return "systemRoleType";
    }

    @Override
    public String getCurrentEntityInstanceName() {
        if (getCurrent() != null) {
            return getCurrent().getName();
        }
        return "";
    }

    @Override
    public SystemRoleType findById(Integer id) {
        return systemRoleTypeDbFacade.findById(id);
    }
    
    @FacesConverter(forClass = SystemRoleType.class)
    public static class SystemRoleTypeControllerConverter implements Converter {

        @Override
        public Object getAsObject(FacesContext facesContext, UIComponent component, String value) {
            if (value == null || value.length() == 0) {
                return null;
            }
            SystemRoleTypeController controller = (SystemRoleTypeController) facesContext.getApplication().getELResolver().
                    getValue(facesContext.getELContext(), null, "systemRoleTypeController");
            return controller.getEntity(getKey(value));
        }

        java.lang.Integer getKey(String value) {
            java.lang.Integer key;
            key = Integer.valueOf(value);
            return key;
        }

        String getStringKey(java.lang.Integer value) {
            StringBuilder sb = new StringBuilder();
            sb.append(value);
            return sb.toString();
        }

        @Override
        public String getAsString(FacesContext facesContext, UIComponent component, Object object) {
            if (object == null) {
                return null;
            }
            if (object instanceof SystemRoleType) {
                SystemRoleType o = (SystemRoleType) object;
                return getStringKey(o.getId());
            } else {
                throw new IllegalArgumentException("Object " + object + " is of type " + object.getClass().getName() + "; expected type: " + SystemRoleType.class.getName());
            }
        }

    }

}
