/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.anl.aps.dm.portal.model.beans;

import gov.anl.aps.dm.portal.model.entities.ExperimentStation;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;

/**
 *
 * @author sveseli
 */
@Stateless
public class ExperimentStationDbFacade extends DmEntityDbFacade<ExperimentStation> {

    @PersistenceContext(unitName = "DmWebPortalPU")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public ExperimentStationDbFacade() {
        super(ExperimentStation.class);
    }

    public ExperimentStation findByName(String name) {
        try {
            return (ExperimentStation) em.createNamedQuery("ExperimentStation.findByName")
                    .setParameter("name", name)
                    .getSingleResult();
        } catch (NoResultException ex) {
        }
        return null;
    }
    
    public ExperimentStation findById(Integer id) {
        try {
            return (ExperimentStation) em.createNamedQuery("ExperimentStation.findById")
                    .setParameter("id", id)
                    .getSingleResult();
        } catch (NoResultException ex) {
        }
        return null;
    }    
}
