/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.anl.aps.dm.portal.model.entities;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author sveseli
 */
@Entity
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Endpoint.findAll", query = "SELECT e FROM Endpoint e")
    , @NamedQuery(name = "Endpoint.findById", query = "SELECT e FROM Endpoint e WHERE e.id = :id")
    , @NamedQuery(name = "Endpoint.findByName", query = "SELECT e FROM Endpoint e WHERE e.name = :name")
    , @NamedQuery(name = "Endpoint.findByAccessUrl", query = "SELECT e FROM Endpoint e WHERE e.accessUrl = :accessUrl")
    , @NamedQuery(name = "Endpoint.findByDescription", query = "SELECT e FROM Endpoint e WHERE e.description = :description")})
public class Endpoint extends DmEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    private Integer id;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 2147483647)
    private String name;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 2147483647)
    @Column(name = "access_url")
    private String accessUrl;
    @Size(max = 2147483647)
    private String description;
    @JoinColumn(name = "storage_id", referencedColumnName = "id")
    @ManyToOne(optional = false)
    private Storage storageId;

    public Endpoint() {
    }

    public Endpoint(Integer id) {
        this.id = id;
    }

    public Endpoint(Integer id, String name, String accessUrl) {
        this.id = id;
        this.name = name;
        this.accessUrl = accessUrl;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getAccessUrl() {
        return accessUrl;
    }

    public void setAccessUrl(String accessUrl) {
        this.accessUrl = accessUrl;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Storage getStorageId() {
        return storageId;
    }

    public void setStorageId(Storage storageId) {
        this.storageId = storageId;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Endpoint)) {
            return false;
        }
        Endpoint other = (Endpoint) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities2.Endpoint[ id=" + id + " ]";
    }
    
}
